#ifndef MUON_ORBIT_PROCESSOR_H
#define MUON_ORBIT_PROCESSOR_H

#include "orbit_processor.h"

class MuonOrbitProcessor : public OrbitProcessor {
  using OrbitProcessor::OrbitProcessor;

 protected:
  FillOrbitMetadata FillOrbit(orbit_trailer *trailer, char *rd_ptr, char *wr_ptr,
                              const char *rd_end_ptr, const char *wr_end_ptr) override;

  inline uint32_t GetOrbitSizeInBytes(const FillOrbitMetadata &meta) const override {
    // 12 bytes for each muon/count then 12 bytes for each bx header
    return meta.counts * 12 + 12 * meta.filled_bxs;
  }
};

#endif  // MUON_ORBIT_PROCESSOR_H